#version 300 es

uniform mat4 u_Model;
uniform mat4 u_TransposeInvModel;
uniform mat4 u_MVP;
uniform vec2 _Offset;
uniform vec2 _Tiling;
uniform float _Rotation;

out vec3 v_posWS;
layout(location = 0) in vec3 attPosition;
out vec3 v_nDirWS;
layout(location = 2) in vec3 attNormal;
out vec2 v_uv0;
layout(location = 1) in vec2 attTexcoord0;

vec2 UV_TRS(vec2 inputUV, vec2 uvCenter, vec2 uvPan, vec2 uvScale, float uvRotate)
{
    vec2 minusCenterUV = inputUV - uvCenter;
    float cosVal = cos(uvRotate);
    float sinVal = sin(uvRotate);
    mat2 rotateMat = mat2(vec2(cosVal, -sinVal), vec2(sinVal, cosVal));
    vec2 outputUV = minusCenterUV * uvScale;
    outputUV = (rotateMat * outputUV) + uvCenter;
    outputUV += uvPan;
    return outputUV;
}

void main()
{
    v_posWS = (u_Model * vec4(attPosition, 1.0)).xyz;
    v_nDirWS = (u_TransposeInvModel * vec4(attNormal, 0.0)).xyz;
    gl_Position = u_MVP * vec4(attPosition, 1.0);
    v_uv0 = vec2(attTexcoord0.x, 1.0 - attTexcoord0.y);
    vec2 param = v_uv0;
    vec2 param_1 = vec2(0.5);
    vec2 param_2 = _Offset;
    vec2 param_3 = _Tiling;
    float param_4 = _Rotation / 57.295780181884765625;
    v_uv0 = UV_TRS(param, param_1, param_2, param_3, param_4);
}

